<template>
  <div
    class="language-select group flex items-center text-gray-700"
    :class="{
      'focus-within:text-violet-800 hover:text-violet-800':
        !supportNoScript || javaScriptEnabled,
    }"
  >
    <language-icon
      class="pointer-events-none absolute h-[1.25em] w-[calc(1.25em+0.5rem)] stroke-2 pl-2"
      :class="{
        'group-focus-within:text-violet-700 group-hover:text-violet-700':
          supportNoScript && !javaScriptEnabled,
      }"
    />
    <nav
      v-if="supportNoScript && !javaScriptEnabled"
      aria-describedby="noscript-language"
      class="no-script peer my-1 flex items-center bg-transparent pl-8 text-sm font-medium md:my-0 md:justify-center lg:text-lg"
    >
      <p id="noscript-language" class="sr-only">
        {{ label }}
      </p>
      <ul>
        <li
          v-for="(locale, index) of locales"
          :key="locale.code"
          class="inline-block"
        >
          <!--
            The pseudo element styles are used to set the link width to the width it would have if it
            was active and the bold font was applied. This prevents layout shifts on page navigation.
          -->
          <router-link
            :to="locale.to"
            :hreflang="locale.code"
            :lang="locale.code"
            :data-label="locale.name"
            class="inline-block cursor-pointer rounded border-none p-2 outline-none before:invisible before:block before:h-0 before:overflow-hidden before:font-bold before:content-[attr(data-label)] focus-within:bg-violet-100 hover:bg-violet-100 hover:text-violet-800 hover:underline focus:bg-violet-100 focus:text-violet-800 focus:underline focus:ring-2 focus:ring-violet-700"
            exact-active-class="font-bold"
          >
            {{ locale.name }}
          </router-link>
          <span
            v-if="index + 1 < locales.length"
            class="mx-1 inline-block select-none text-gray-400"
            aria-hidden="true"
            >/</span
          >
        </li>
      </ul>
    </nav>
    <label for="language-select" class="sr-only peer-[.no-script]:hidden">{{
      label
    }}</label>
    <select
      id="language-select"
      v-model="selected"
      class="my-1 flex cursor-pointer items-center rounded border-none bg-transparent pl-8 text-sm font-medium outline-none hover:bg-violet-100 hover:text-violet-800 focus:bg-violet-100 focus:text-violet-800 focus:ring-2 focus:ring-violet-700 peer-[.no-script]:hidden md:my-0 md:justify-center lg:text-lg"
    >
      <option v-for="locale of locales" :key="locale.code" :value="locale.code">
        {{ locale.name }}
      </option>
    </select>
  </div>
</template>

<script lang="ts" setup>
import { computed, onMounted, PropType, ref } from 'vue'
import { LanguageIcon } from '@heroicons/vue/24/outline'
import { LanguageSelectLocaleItem } from '../../propInterfaces'

defineOptions({
  name: 'UiLanguageSelect',
})

const props = defineProps({
  label: {
    type: String,
    default: 'Select language',
  },

  locales: {
    type: Array as PropType<LanguageSelectLocaleItem[]>,
    default: () => [],
    validator: (locales: LanguageSelectLocaleItem[]) => {
      return locales.every((locale) => locale.code && locale.name && locale.to)
    },
  },

  selectedLocale: {
    type: String,
    default: undefined,
  },

  supportNoScript: {
    type: Boolean,
    default: true,
  },
})

const emit = defineEmits(['update'])

const javaScriptEnabled = ref(false)

const selected = computed({
  get() {
    return props.selectedLocale ?? ''
  },
  set(code: string) {
    if (code !== props.selectedLocale) {
      emit('update', code)
    }
  },
})

onMounted(() => {
  javaScriptEnabled.value = true
})
</script>
